
-- Dumping structure for table autodb.chargingprovider
DROP TABLE IF EXISTS `chargingprovider`;
CREATE TABLE IF NOT EXISTS `chargingprovider` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Levrandørens navn',
  `userName` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Brukerbavb',
  `password` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Passord',
  `token` varchar(256) DEFAULT NULL,
  `STATUS` tinyint(4) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

-- Dumping data for table autodb.chargingprovider: ~0 rows (approximately)
DELETE FROM `chargingprovider`;
/*!40000 ALTER TABLE `chargingprovider` DISABLE KEYS */;
INSERT INTO `chargingprovider` (`id`, `name`, `userName`, `password`, `token`, `STATUS`) VALUES
	(1, 'Eviny', '', '', '', 0),
	(2, 'EON', '', '', '', 0);
/*!40000 ALTER TABLE `chargingprovider` ENABLE KEYS */;

-- Dumping structure for table autodb.chargingproviderbinding
DROP TABLE IF EXISTS `chargingproviderbinding`;
CREATE TABLE IF NOT EXISTS `chargingproviderbinding` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tagid` int(11) NOT NULL DEFAULT 0,
  `providerid` int(11) NOT NULL DEFAULT 0,
  `status` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `tagid` (`tagid`),
  KEY `providerid` (`providerid`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

-- Dumping data for table autodb.chargingproviderbinding: ~1 rows (approximately)
DELETE FROM `chargingproviderbinding`;
/*!40000 ALTER TABLE `chargingproviderbinding` DISABLE KEYS */;
INSERT INTO `chargingproviderbinding` (`id`, `tagid`, `providerid`, `status`) VALUES
	(1, 3, 1, 1);
/*!40000 ALTER TABLE `chargingproviderbinding` ENABLE KEYS */;


-- Dumping structure for table autodb.chargingtag
DROP TABLE IF EXISTS `chargingtag`;
CREATE TABLE IF NOT EXISTS `chargingtag` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rfidNumber` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0' COMMENT 'rfid kort identifikasjon',
  `created` datetime DEFAULT NULL COMMENT 'opprettet',
  `createdby` int(11) NOT NULL COMMENT 'opprettet av',
  `description` varchar(50) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'beskrivelse av kort',
  PRIMARY KEY (`id`),
  UNIQUE KEY `rfidNumber` (`rfidNumber`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- Dumping data for table autodb.chargingtag: ~0 rows (approximately)
DELETE FROM `chargingtag`;
/*!40000 ALTER TABLE `chargingtag` DISABLE KEYS */;
INSERT INTO `chargingtag` (`id`, `rfidNumber`, `created`, `createdby`, `description`) VALUES
	(1, '1234123412341234', '2021-04-16 09:19:27', 20, 'Skap 01, Reservert for gjester'),
	(2, '258965002356', '2021-04-21 16:17:56', 21, 'Skap 02'),
	(3, '1122334455', '2022-03-16 08:48:31', 32, 'test');
/*!40000 ALTER TABLE `chargingtag` ENABLE KEYS */;

-- Dumping structure for table autodb.chargingtagbinding
DROP TABLE IF EXISTS `chargingtagbinding`;
CREATE TABLE IF NOT EXISTS `chargingtagbinding` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tagid` int(11) NOT NULL DEFAULT 0,
  `assetno` int(11) NOT NULL DEFAULT 0,
  `userid` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `tagid` (`tagid`,`assetno`,`userid`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- Dumping data for table autodb.chargingtagbinding: ~4 rows (approximately)
DELETE FROM `chargingtagbinding`;
/*!40000 ALTER TABLE `chargingtagbinding` DISABLE KEYS */;
INSERT INTO `chargingtagbinding` (`id`, `tagid`, `assetno`, `userid`) VALUES
	(2, 1, 81, 0),
	(3, 2, 31, 0),
	(4, 3, 52, 0);
/*!40000 ALTER TABLE `chargingtagbinding` ENABLE KEYS */;

-- Dumping structure for table autodb.charging
DROP TABLE IF EXISTS `charging`;
CREATE TABLE IF NOT EXISTS `charging` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`chargerId` VARCHAR(50) NOT NULL COLLATE utf8mb4_unicode_ci DEFAULT '0',
`date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
`brand` VARCHAR(50) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
`price` decimal(10,2) NOT NULL DEFAULT 0.00,
`kwh` decimal(10,2) NOT NULL DEFAULT 0.00,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;


