package etc.ajax.charging;

import etc.ajax.AjaxClass;
import etc.ajax.AjaxLogic;
import etc.beans.user.Rights;
import etc.beans.user.RoleAction;
import etc.beans.user.SolutionSessionInfo;
import etc.caradmin.io.CarAdminException;
import etc.caradmin.io.sql.SQLBuilder;
import etc.caradmin.io.sql.SQLFactory;
import etc.util.json.JSONArray;
import etc.util.json.JSONException;
import etc.util.json.JSONObject;
import org.apache.commons.lang3.StringUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

/**
 * Klasse for � s�ke opp ladebrikke
 *  @author Rihards D. U.
 */
@AjaxClass
public class ChargingTagSearch extends AjaxLogic {
    @Override
    public void doLogic(SolutionSessionInfo si, HttpServletRequest request, HttpServletResponse response) throws IOException {
        String hitTest =null;
        JSONArray json =  new JSONArray();
        try {
            if(Rights.hasRight(si, RoleAction.ViewFuelbook)){//TODO lader rettigheter
                if (request.getParameter("term") != null) {
                    hitTest = request.getParameter("term");
                }

                if (hitTest == null) {
                    hitTest = "";
                } else if(hitTest.endsWith("*")) {
                    hitTest = hitTest.substring(0, hitTest.length()-1);
                }

                if (hitTest.startsWith("�")) { //NB! Ikke vanlig space men, "alt+255"
                    hitTest = hitTest.substring(1);
                }

                if (hitTest.contains("�")) { //Ikke vanlig space men, "alt+255"
                    hitTest = hitTest.substring(hitTest.indexOf("�")+1); //Ikke vanlig space men, "alt+255"
                }

                hitTest = hitTest.trim();

                //s�k p� teksten hvorsomhelst i kortnummeret
                //String fuelCardSql = "SELECT * FROM fuelcard WHERE cardnumber like ?";
                //^gjenliggende komentar fra drivstofkort

                String chargingTagSql = "SELECT chargingtag.*, count(chargingtagbinding.tagid) as assets, general.carid  FROM chargingtag " +
                        "left join chargingtagbinding on chargingtagbinding.tagid = chargingtag.id " +
                        "left join general on general.carno = chargingtagbinding.assetno " +
                        "WHERE rfidNumber like ? ESCAPE '!' GROUP BY chargingtag.id ORDER BY chargingtag.rfidNumber ASC";

                hitTest = SQLBuilder.prepareGlobalSearch(hitTest);

                List<String> doneStrings = new ArrayList<>();
                String more = si.getMsg().t("FuelCard.SearchMoreAssets");
                try(Connection c = si.getSqlFactory().getConnection() ) {
                    try(PreparedStatement p = c.prepareStatement(chargingTagSql)) {
                        p.setString(1, hitTest);
                        try(ResultSet rs = p.executeQuery() ) {
                            if (rs.first()) {
                                do {
                                    String name = rs.getString("rfidNumber");
                                    int id = rs.getInt("id");
                                    int assets = rs.getInt("assets");
                                    String carid = rs.getString("carid");
                                    if (!doneStrings.contains(name)) {
                                        doneStrings.add(name);
                                        if(StringUtils.isNotBlank(carid)){
                                            name += " ("+carid;
                                            if(assets > 1){
                                                name += " + "+(assets-1)+" "+more;
                                            }
                                            name+=")";
                                        }
                                        JSONObject item = new JSONObject();
                                        item.put("value",id);
                                        item.put("label", name);
                                        json.put(item);
                                    }

                                }while(rs.next());
                            }
                        }
                    }
                } catch (Exception e) {
                    log.error("Feil under uthenting av ladebrikker for s�king", e);
                }
            }

            json.write(response.getWriter() );
            response.getWriter().flush();
        } catch (JSONException | IOException | CarAdminException e) {
            log.error("feil ved uthenting av ladebrikker",e);
        }
    }
}