package etc.ajax.charging;

import etc.caradmin.io.CarAdminException;
import etc.caradmin.mvc.controller.charging.ChargingTag;
import etc.io.ClassFactory;
import etc.io.expence.ChargeIO;
import etc.ajax.AjaxClass;
import etc.ajax.AjaxLogic;
import etc.ajax.chargingTagProviderParsing.ChargingTagProviderParser;
import etc.beans.user.SolutionSessionInfo;
import etc.caradmin.mvc.controller.charging.ChargingProvider;
import etc.caradmin.mvc.util.WebUtils;
import etc.util.json.JSONArray;
import etc.util.json.JSONException;
import etc.util.json.JSONObject;
import lombok.extern.log4j.Log4j2;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Objects;

@Log4j2
@AjaxClass
public class SaveChargingProvider extends AjaxLogic {

    @Override
    public void doLogic(
            final SolutionSessionInfo si, final HttpServletRequest request, final HttpServletResponse response
    ) throws IOException {

        String rfidnummer = WebUtils.getStringOrDefault(request, null, si, "rfidnummer");
        String bilnummer = WebUtils.getStringOrDefault(request, null, si, "bilnummer");
        String[] checkmarks = WebUtils.getStringArrayOrDefault(request, "checkmarks");

        ChargingTagProviderParser parser = new ChargingTagProviderParser();

        JSONArray res = new JSONArray();

        for(String checkmark : checkmarks) {
            if(Objects.equals(checkmark, "bilkraft")) {
                ChargeIO cio = ClassFactory.getChargeIO(si.getSqlFactory());
                try {
                    ChargingProvider chargingProvider = cio.getChargingProviderByName("Eviny");

                    String token = chargingProvider.getToken();

                    String result = parser.bilkraftPost(rfidnummer, bilnummer, token);

                    int id = cio.getChargingProviderByName("Eviny").getId();

                    JSONObject a = new JSONObject();
                    a.put("rfidnumber", rfidnummer);

                    switch(result) {
                        case "SUCCESS": insertProviderBinding(cio, rfidnummer, id, 1); a.put("response", "success"); break;
                        case "RFID_IS_IN_USE": insertProviderBinding(cio, rfidnummer, id, 1); a.put("response", "fail"); break;
                        case "FAIL": insertProviderBinding(cio, rfidnummer, id, 2); a.put("response", "fail"); break;
                    }

                    a.put("provider", "EVINY");

                    res.put(a);

                } catch(CarAdminException e) {
                    e.printStackTrace();
                }
            }

            if(Objects.equals(checkmark, "EON")){

                ChargeIO cio = ClassFactory.getChargeIO(si.getSqlFactory());
                try {
                    ChargingProvider chargingProvider = cio.getChargingProviderByName("EON");

                    String token = chargingProvider.getToken();

                    String result = parser.eonPost(rfidnummer, token);

                    int id = cio.getChargingProviderByName("EON").getId();

                    JSONObject a = new JSONObject();
                    a.put("rfidnumber", rfidnummer);

                    switch(result) {
                        case "SUCCESS": insertProviderBinding(cio, rfidnummer, id, 1); a.put("response", "success"); break;
                        case "FAIL": insertProviderBinding(cio, rfidnummer, id, 1); a.put("response", "fail"); break;
                    }

                    a.put("provider", "EON");

                    res.put(a);

                } catch(CarAdminException e) {
                    e.printStackTrace();
                }
            }
        }

        try {
            res.write(response.getWriter());
            response.getWriter().flush();
        } catch(JSONException e) {
            e.printStackTrace();
        }


    }

    /**
     * bruker ChargeIO funksjoner til � hente chargingtag nummer, og bruke det til � legge inn en ny chargingproviderbinding.
     * @param cio
     * @param rfidnummer
     * @param id
     * @param status
     */
    void insertProviderBinding(ChargeIO cio, String rfidnummer, int id, int status) {
        ChargingTag ct = null;
        try {
            ct = cio.getChargingTagByNumber(rfidnummer);
            if(ct != null){
                cio.addChargingProviderBinding(ct.getId(), id, status);
            }
        } catch(CarAdminException e) {
            e.printStackTrace();
        }
    }
}

