package etc.ajax.chargingTag;

import etc.ajax.AjaxClass;
import etc.ajax.charging.ChargingTagReport;
import etc.ajax.reports.DatahandlingContract;
import etc.ajax.util.JsonReportToExcelExport;
import etc.beans.user.SolutionSessionInfo;
import etc.caradmin.beans.table.RowBO;
import etc.caradmin.io.CarAdminException;
import etc.util.json.JSONException;
import etc.util.json.JSONObject;
import etc.util.lang.Messages;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Klasse for � eksportere drivstoffkort til excel
 *  @author Rihards D. U.
 */
@AjaxClass
public class ChargingTagExport extends JsonReportToExcelExport {

    /**
     * Angir om denne rapportklassen h�ndterer personlige opplysninger.
     *
     * @return true hvis den h�ndterer personlige opplysninger, false ellers.
     */
    @Override
    protected DatahandlingContract getDatahandlingContract() {
        return DatahandlingContract.NonPersonalContract;
    }


    @Override
    public void doLogic(SolutionSessionInfo si, HttpServletRequest request, HttpServletResponse response) throws IOException {
        ChargingTagReport fcr = new ChargingTagReport();

        JSONObject json = fcr.createJsonReport(si, request);

        Messages m = si.getMsg();

        RowBO header = new RowBO();

        List<String> cols  = new ArrayList<>();
        cols.add("rfidNumber");
        cols.add("description");
        cols.add("assets");
        cols.add("providers");
        cols.add("createdby");
        cols.add("created");

        String name =  m.getString("FuelCard.FuelCards");
        String translationPrefix = "ChargingTag.";
        header.addCell(name).setColumnSpan(20);

        try {
            generateAndExport(si, response, json, cols, name, translationPrefix,header);
        } catch (JSONException | CarAdminException e) {
            log.error("Noe gikk galt i exceleksport av drivstoffkort",e);
        }
    }
}
