package etc.ajax.chargingTag;

import etc.ajax.AjaxClass;
import etc.ajax.AjaxLogic;
import etc.beans.user.SolutionSessionInfo;
import etc.util.json.JSONArray;
import etc.util.json.JSONException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@AjaxClass
public class GetDbLoginUserInfo extends AjaxLogic {

    @Override
    public void doLogic(
            final SolutionSessionInfo si, final HttpServletRequest request, final HttpServletResponse response
    ) throws IOException {
        try {
            ChargingProviderLogin c = new ChargingProviderLogin();
            JSONArray jsonUserInfo = c.getDbUserInfo(si);
            if (jsonUserInfo == null) {
                jsonUserInfo = new JSONArray();
            }
            jsonUserInfo.write(response.getWriter());
            response.getWriter().flush();

        } catch (JSONException | java.io.IOException e) {
            log.error("Feil ved henting av bruker-info til ladeselskap", e);
            response.setStatus(HttpServletResponse.SC_INTERNAL_SERVER_ERROR);
        }
    }
}
