package etc.caradmin.mvc.controller.charging;

import etc.beans.user.RoleAction;
import etc.caradmin.io.CarAdminException;
import etc.caradmin.mvc.PageControllerAction;
import etc.caradmin.mvc.util.ReportDetailController;
import etc.caradmin.mvc.util.WebUtils;
import etc.io.ClassFactory;
import etc.io.expence.ChargeIO;
import etc.util.report.ReportDetail;
import etc.util.report.detail.LabelReportDetail;
import org.jetbrains.annotations.NotNull;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;


@PageControllerAction(rights= RoleAction.ViewFuelbook)
public class ChargingHistoryDetails extends ReportDetailController {
    /**
     * Legger til data som vises nr man trykker p handling i oversikten over ladinger.
     *
     * @param request foresprselsobjektet som inneholder parametre
     * @return
     * @throws CarAdminException
     */
    @NotNull
    @Override
    protected List<ReportDetail> getReportDetails(final HttpServletRequest request) throws CarAdminException {
        List<ReportDetail> dets = new ArrayList<>();
        int id = WebUtils.getIntOrDefault(request, null, "chargeId");

        if(id > 0){

            ChargeIO cio = ClassFactory.getChargeIO(si.getSqlFactory());
            ChargingSessionData data = cio.getChargingSessionById(id);

            LabelReportDetail det = new LabelReportDetail();
            det.setHeading(m.t("Charging"));
            det.addData(m.t("Charger.Brand"), data.getBrand());
            det.addData(m.t("Charger.ChargerId"), data.getChargerId());
            det.addData(m.t("Charger.Date"), data.getDate());
            det.addData(m.t("Charger.Price"), data.getPrice().toString());
            det.addData(m.t("Charger.Kwh"), data.getKwh().toString());
            dets.add(det);

        }

        return dets;
    }
}
