package etc.caradmin.mvc.controller.charging;

import etc.caradmin.beans.Data;
import etc.util.DateTime;
import etc.util.schema.InputParameter;
import etc.util.settings.FieldType;
import lombok.EqualsAndHashCode;

import javax.annotation.Nullable;
import java.io.Serializable;
import java.util.List;

/**
 * Dataobjekt for ladebrikke
 *  @author Rihards D. U.
 */
@EqualsAndHashCode(callSuper = true)
@lombok.Data
public class ChargingTag extends Data implements Serializable {
    /**
     * Id
     */
    private int id;
    /**
     * Kortnummer
     */
    @InputParameter(type= FieldType.StringSetting, required = true, order = 1)
    private String rfidNumber;
    /**
     * Beskrivelse/kommentar
     */
    @InputParameter(type=FieldType.TextArea, required = false, order = 2)
    private String description;
    /**
     * Opprettet dato
     */
    private DateTime created;
    /**
     * Opprettet av
     */
    private int createdBy;
    /**
     * Tilknyttede kj�ret�y
     */
    private List<Integer> assets;
    /**
     * Tilknyttede brukere
     */
    private List<Integer> users;

    /**
     * Anonymiser nummer p� drivstoffkortet
     *
     * @return kortnummer med enkelte tall byttet ut med "x"
     */
}
