package etc.caradmin.mvc.controller.charging;

import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;
import org.json.JSONArray;
import org.json.JSONObject;

import java.io.IOException;
import java.time.LocalDate;
import java.time.LocalDateTime;

public class GetChargingDataEnode {

    private final EnodeWebhookAPI enodeClass = new EnodeWebhookAPI();

    /**
     * Henter access token fra Enode til  bruke i API kall.
     *
     * @return accesToken - Access token fra Enode
     */
    public String getAccesToken(){


        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded");
        RequestBody body = RequestBody.create(mediaType, "grant_type=client_credentials");
        Request request = new Request.Builder()
                .url("https://oauth." + enodeClass.getEnvironment() + ".enode.io/oauth2/token")
                .method("POST", body)
                .addHeader("Authorization", "Basic Y2I4MzM4MDEtNjdkMy00MzRkLThhNjktYWQyMzVlNDJjMWQ0OlZzLmpPUGJfLnRUUnVfdzF6cUlHeGlwa35z")
                .addHeader("Content-Type", "application/x-www-form-urlencoded")
                .build();
        Response response = null;
        try {
            response = client.newCall(request).execute();
        } catch(IOException e) {
            e.printStackTrace();
            System.out.println("Enode http call to get acces token failed");
        }

        String jsonResToken = null;
        try {
            jsonResToken = response.body().string();
        } catch(IOException e) {
            e.printStackTrace();
            System.out.println("Failed to read body with access token");
        }

        try {
            JSONObject jo = new JSONObject(jsonResToken);
            String accessToken = jo.getString("access_token");
            return accessToken;
        }catch(Exception e){
            System.out.println("Failed to read access token from body");
        }


        return null;

    }

    /**
     *
     * @param customerSolution
     * @param chargerId
     * @param date
     * @param accessToken
     * @return
     */
    public String getChargingData(String customerSolution, String chargerId, String date, String accessToken){


        LocalDateTime now = LocalDateTime.now();

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        Request request = new Request.Builder()
                .url("https://enode-api." + enodeClass.getEnvironment() + ".enode.io/statistics/charging?startDate=" + date + "&endDate=" + now + "&type=charger&id=" + chargerId)
                .method("GET", null)
                .addHeader("Authorization", "Bearer " + accessToken)
                .addHeader("Enode-User-Id", customerSolution)
                .build();

        Response response = null;
        try {
            response = client.newCall(request).execute();
        } catch(IOException e) {
            e.printStackTrace();
        }

        String jsonStr = null;
        try {
            jsonStr = response.body().string();
        } catch(IOException e) {
            e.printStackTrace();
        }


        return jsonStr;
    }

}
