
<%@ page language="java" contentType="text/html; charset=utf-8" pageEncoding="ISO-8859-1"   %>
<%@ taglib prefix="etc" uri="/WEB-INF/tags.tld" %>

<etc:LabelValueFunctionList objectList="${apisettingslist}"/>
<etc:LabelValueFunctionList objectList="${adSettingsList}" headingItem="${adSettingsHeading}"/>
<etc:LabelValueFunctionList objectList="${adCostUnitFields}" headingItem="${adCostunitsFieldsHeading}"/>
<etc:LabelValueFunctionList objectList="${prodList}" headingItem="${prodHeading}"/>
<etc:LabelValueFunctionList objectList="${fuelImportList}" headingItem="${fuelImportHeading}"/>
<etc:LabelValueFunctionList objectList="${tollTagSettingList}" headingItem="${tollTagHeading}"/>
<etc:LabelValueFunctionList objectList="${roadMaintenanceColorSchemes}" headingItem="${colorSchemeHeading}"/>
<etc:LabelValueFunctionList objectList="${dimSettings}" headingItem="${dimHeading}"/>
<etc:LabelValueFunctionList objectList="${espList}" headingItem="${ExternalProductCatalogHeading}"/>
<etc:LabelValueFunctionList objectList="${chargingProviderList}" headingItem="${chargingProviderHeading}"/>


<div id="apiSettingsDialogHolder"></div>

<div>
<etc:FilledButton
        id="Button1"
        text="Registrer lader hos Enode"
        cssClass="btn-green-next"
        action="openEnodeLink();" />

</div>
<p id="message"></p>


<script>
	function getDialog(di){	
		var url = '${solutionUrl}/x/'+di
		var data = {};
		var diag = "apiSettingsDialogHolder";
		dialogLinkItemShow(url, data, diag);
	}
    
    // @author: Elliot Sveum Torp
    function editLoginInfo(provider) {
        var url = '${solutionUrl}/x/ApiSettingsChargingProviders'
        var data = {};
        data.edit = provider;
        var diag = 'apiSettingsDialogHolder'
        dialogLinkItemShow(url, data, diag);
    }
	
	function removeProductOnAPI(prodid){
		var url = '/${solutionUrl}/x/ApiSettingsProducts';
		var data = {'removeProduct':prodid};
		etcNavigate(url, data);
		
	}

    function removeImportFormatOnAPI(format){
        var url = '/${solutionUrl}/x/ApiSettingsFuelImport';
        var data = {'removeFormat':format};
        etcNavigate(url, data);
    }

    function removeTollTagOnAPI(id){
        var url = '/${solutionUrl}/x/ApiSettingsTollTagSupplier';
        var data = {'removeId':id};
        etcNavigate(url, data);
    }

    function removeColorScheme(id){
        $.ajax({
            type: 'POST',
            url: '/ChangeColorScheme.ajax',
            data: {id:id,customer_id:'${solutionDb}', deleteColorScheme: true},
            dataType: 'json',
            success: function (data) {
                window.location.reload();
            }
        });
    }

    function editColorScheme(id){
        var data = {"id":id}
        dialogLinkItemShow('${solutionUrl}/x/ColorSchemeDialog', data, 'apiSettingsDialogHolder');
    }

    function updateAdSettings(settingName) {
	    var data = {
            ADSetting: settingName
        };
        dialogLinkItemShow('${solutionUrl}/x/EditADSettingsDialog', data, 'apiSettingsDialogHolder');

    }

    function removeExternalProductSupplierOnAPI(id){
	    var url = '/${solutionUrl}/x/ApiSettingsExternalProductCatalog';
        var data = {'removeId':id, deleteExProdCat:true};
        etcNavigate(url, data);
    }

    function setTripDefaultDimension(){
        dialogLinkItemShow('${solutionUrl}/x/DimensionSettingDialog', {isTripStandard : true}, 'apiSettingsDialogHolder');
    }
    function setDimensionSeparator(){
	    dialogLinkItemShow('${solutionUrl}/x/DimensionSettingDialog', {isSeparator : true}, 'apiSettingsDialogHolder');
    }
    function setUserDefaultDimension(){
	    dialogLinkItemShow('${solutionUrl}/x/DimensionSettingDialog', {isUserStandard : true}, 'apiSettingsDialogHolder');
    }
    function setAssetDefaultDimension(){
	    dialogLinkItemShow('${solutionUrl}/x/DimensionSettingDialog', {isAssetStandard : true}, 'apiSettingsDialogHolder');
    }

    function editAdCostUnitField(id){
        var data = {"dimensionId":id}
        dialogLinkItemShow('${solutionUrl}/x/AdCostUnitFieldsDialog', data, 'apiSettingsDialogHolder');
    }
    function removeAdCostUnitField(id){
        var url = '/${solutionUrl}/x/AdCostUnitFieldsDialog';
        var data = {'removeFieldBinding':id};
        etcNavigate(url, data);
    }
    
    // @author: Sindre Vikre
    async function openEnodeLink() {


        document.getElementById("message").innerHTML = "";

        var data = {};
        data.customer_id = '${solutionDb}';

        var win = window.open('', "_blank");

        $.ajax({
            url: "/ChargingEnodeLink.ajax",
            type: "POST",
            dataType: "json",
            data: data,
            success: function(data) {
                if(!data || data.error) {

                    document.getElementById("message").innerHTML = "Kunne ikke koble til enode. Ta kontakt hvis " +
                        "problemet vedvarer.";
                    win.close();

                } else {


                    const status = data.status;
                    if(status !== "error"){
                        const link = data.urlEnode;
                        win.location = link.toString();
                    }else{
                        win.close();
                        const message = data.message;
                        document.getElementById("message").innerHTML = message.toString();

                    }
                }
            }
        });
    }

</script>
