<%@ page contentType="text/html; charset=ISO-8859-1" language="java" pageEncoding="ISO-8859-1" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="etc" uri="/WEB-INF/tags.tld" %>
<etc:DialogHeader iconPath="/images/newdesign/maintenance.png" customClose="closeChargingProviderRegisterDialog" title='${not empty chargingTagId  ? m["ChargingProvider.RegisterTag"] : m["ChargingProvider.RegisterTag"]}' />
<html>
<head>
    <title>Title</title>
</head>
<body>
<div>
    <form>

        <div id="progressbar" style="width: calc(100% - 2px); border: 1px solid #000000; display:none">
            <div id="backgroundColor" style="background-color: #00ff26; height: 20px; width:0;text-align: left"></div>
        </div>

        <div id="checkboxes">
            <div id="checkboxesEviny">
                <etc:Checkbox checkboxId="Eviny" label="Bilkraft(Eviny)"></etc:Checkbox>
                <img src="/images/newdesign/loading.gif" id = "EvinyStatus" height="15px" width="15px">
            </div>
            <div id="checkboxesEON">
                <etc:Checkbox checkboxId="EON" label="EON"></etc:Checkbox>
                <img src="/images/newdesign/loading.gif" id = "EONStatus" height="15px" width="15px">
            </div>
        </div>

        <div id="resultDiv">
        </div>

        <div style="margin-top:20px">
            <etc:ModernButton text='${m["Close"]}' image="Cancel_50px_white.png" color="#FFF" bgcolor="#b7b7b7" onclick="closeChargingProviderRegisterDialog()" id="CloseButton"/>
            <etc:ModernButton text="${m['Register']}" image="Circled_Right_2_50px_white.png" color="#fff" bgcolor="#8FBF21" onclick="register();" id="SaveButton"></etc:ModernButton>

    </div>
    </form>
</div>
</body>
</html>

<script>
    hideBoxes();
    getDbLoginInfo();

    function hideBoxes() {
        document.getElementById("checkboxesEviny").style.display = "none";
        document.getElementById("checkboxesEON").style.display = "none";
    }

    function openLoginForm(provider) {
        dialogLinkItemShow("${solutionUrl}/x/ChargingProviderRegisterDialog2",{
            provider: provider,
        },"testDialogId", null, null, null, "testDialogParent");
    }

    function getDbLoginInfo() {
        var data = {};
        data.customer_id = '${solutionDb}';

        $.ajax({
            url: "/GetDbLoginUserInfo.ajax",
            type : "POST",
            dataType: "json",
            data: data,
            success: function(data){
                if(!data || data.error) {

                }else{
                    var providers = false;
                    data.forEach((element => {
                        if(element.status === "registered") {
                            document.getElementById(element.provider + "Status").src = "/images/newdesign/damage/allgood.png"
                            document.getElementById("checkboxes"+element.provider).style.display = "block"
                            providers = true;
                        }else if (element.status === "wrongPass"){
                            document.getElementById(element.provider + "Status").src = "/images/newdesign/bachelorImages/bachelorXImage.png"
                        }else {
                            document.getElementById(element.provider+"Status").src = "/images/newdesign/damage/warn.png"
                        }
                    }))
                    if(!providers){
                        document.getElementById("checkboxes").innerHTML = "<p>Ingen ladeselskap registrert. G til Standardoppsett.</p>"
                    }
                }
            }
        });
    }


    function singleSaveFuelCard(field){
        $(".etc_errortext").hide();
        var formData = $('#fuelCardForm').serializeArray().reduce(function(obj, item) {
            obj[item.name] = item.value;
            return obj;
        }, {});

        var data = {};
        data.customer_id = '${solutionDb}';
        data[field] = formData[field];
        data.fuelCardId = '${fuelCardId}';
        data.singleField = field;

        $.ajax({
            url: "/SaveFuelCard.ajax",
            type : "POST",
            dataType: "json",
            data: data,
            success: function(data){
                if(!data || data.error) {
                    failedFuelCardSave(data);
                    return;
                }
            }
        });
    }

    function register(element){
        var checkmarks = [];

        if(document.getElementById("Eviny").checked) {
            checkmarks.push("bilkraft")
        }

        if(document.getElementById("EON").checked) {
            checkmarks.push("EON")
        }
        console.log("${kjoretoy}")
        console.log("${rfidbrikker}")

        let kjoretoy = "${kjoretoy}".split(',')
        let rfidbrikker = "${rfidbrikker}".split(',')

        console.log(rfidbrikker);

        let data = {};
        data.customer_id = '${solutionDb}';
        data.checkmarks = checkmarks;

        let max = rfidbrikker.length * checkmarks.length;
        let completed = 0;

        document.getElementById("progressbar").style.display = 'block';
        document.getElementById("checkboxes").style.display = 'none';

        for(let i=0; i<rfidbrikker.length; i++) {

            data.rfidnummer = rfidbrikker[i];
            data.bilnummer = kjoretoy[i];

            $.ajax({
                url: "/SaveChargingProvider.ajax",
                type: "POST",
                dataType: "json",
                data: data,
                success: function(data){
                    if(!data || data.error) {
                        console.log("wrong")
                    }else {
                        data.forEach((element => {
                            if(element.response === "success") {
                                completed ++;
                            }else {
                                document.getElementById("resultDiv").innerHTML+='<p>'+element.rfidnumber+' allerede registrert hos '+element.provider+'</p>'
                            }
                        }))
                    }
                    let percent = (completed/max)*100;
                    document.getElementById("backgroundColor").style.width = percent+"%";
                    document.getElementById("backgroundColor").textContent = completed+"/"+max;
                }
            })
        }

        document.getElementById("SaveButton").innerText = "OK"
        document.getElementById("SaveButton").onclick = closeChargingProviderRegisterDialog;
        document.getElementById("CloseButton").style.display = 'none';
    }

    function closeChargingProviderRegisterDialog(){
        $("#dialogLinkItem").dialog("close");
        jsChargingTagOverview.getReport();
    }
</script>