<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="etc" uri="/WEB-INF/tags.tld" %>
<etc:DialogHeader iconPath="/images/newdesign/Link_darkgray.png" customClose="closeChargingTagBindingDialog" title='${bindAsset ? m["ChargingTag.BindAsset"] : m["ChargingTag.BindUser"]}' />
<c:if test="${hasBoundAsset}">
    <div class="caradmin-dialog-text caradmin-dialog-info textCritical" style="max-width: 350px;">
            ${m["ChargingTag.MultiBindAssetWarning"]}
    </div>
</c:if>
<c:choose>
    <c:when test="${not empty chargingTagId}">
        <form name="chargingTagBindingForm" id="chargingTagBindingForm">
            <etc:FieldFormFlex settingsList="${fields}"
                               translationPrefix="ChargingTag."
                               singleSaveFunction="saveChargingTagBinding"
                               singleSaveMode="false"
                               failedSaveFunction="failedChargingTagBindingSave"
                               inputClass="etc_input100 etc_inputMin250"
                               fieldTableName="chargingTagBindingTable"
                               extraFieldTableClass="fieldTable-left-align"
                               includeHidden="true"
                               validateFunction="validateChargingTag"
            ></etc:FieldFormFlex>
        </form>
    </c:when>
    <c:otherwise>
        <div class="caradmin-dialog-text caradmin-dialog-info">
                ${m["ChargingTag.BindError"]}
        </div>
    </c:otherwise>
</c:choose>

<div style="margin-top:20px" class="caradmin-flex-container">
    <c:if test="${not empty chargingTagId}">
        <etc:ModernButton text="${m['Save']}" image="Circled_Right_2_50px_white.png" color="#fff" bgcolor="#8FBF21" onclick="saveChargingTagBinding();"></etc:ModernButton>
    </c:if>
    <etc:ModernButton text='${m["Close"]}' image="Cancel_50px_white.png" color="#FFF" bgcolor="#b7b7b7" onclick="closeChargingTagBindingDialog()"/>
</div>
<script>
    $(document).ready(function(){
        $("#bindAsset_text").on( "autocompletesearch", function( event, ui ) {
            $("#bindAsset").val(0);
        });
    });

    function saveChargingTagBinding(){
        var data = {};
        data.save=true;

        <c:if test="${bindAsset}">
        var val = $("#bindAsset").val();
        data.assetId = val;
        data.saveAsset = true;
        </c:if>
        <c:if test="${bindUser}">
        var val = $("#bindUser").val();
        data.userId = val;
        data.saveUser = true;
        </c:if>
        data.chargingTagId = '${chargingTagId}';
        data.customer_id = '${solutionDb}';

        $.ajax({
            url: "/${solutionUrl}/x/ChargingTagBindingDialog",
            type : "POST",
            dataType: "json",
            data: data,
            success: function(data){
                if(!data || data.error) {
                    failedChargingTagBindingSave(data);
                    return;
                }else {
                    closeChargingTagBindingDialog();
                }
            }
        });

    }

    function closeChargingTagBindingDialog(){
        $("#dialogLinkItem").dialog("close");
        jsChargingTagOverview.getReport();
    }
</script>