<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="etc" uri="/WEB-INF/tags.tld" %>
<etc:DialogHeader iconPath="/images/newdesign/maintenance.png" customClose="closeChargingTagDialog" title='${not empty chargingTagId  ? m["ChargingTag.EditChargingTag"] : m["ChargingTag.NewChargingTag"]}' />
<div>
    <c:choose>
        <c:when test="${tagError}">
            <div class="caradmin-dialog-text caradmin-dialog-info textCritical" style="max-width: 400px;">
                ${m["ChargingTag.LoadError"]}
            </div>
        </c:when>
        <c:otherwise>
            <form name="chargingTagForm" id="chargingTagForm">
                <etc:FieldFormFlex settingsList="${fields}"
                                   translationPrefix="ChargingTag."
                                   singleSaveFunction="singleSaveChargingTag"
                                   singleSaveMode="${not empty chargingTagId and chargingTagId gt 0}"
                                   failedSaveFunction="failedChargingTagSave"
                                   inputClass="etc_input100 etc_inputMin250"
                                   fieldTableName="editChargingTagTable"
                                   extraFieldTableClass="fieldTable-left-align"
                                   includeHidden="true"
                                   validateFunction="validateChargingTag">
                </etc:FieldFormFlex>
            </form>
        </c:otherwise>
    </c:choose>

</div>
<div style="margin-top:20px">
    <c:if test="${empty chargingTagId && not tagError}">
        <etc:ModernButton text="${m['Save']}" image="Circled_Right_2_50px_white.png" color="#fff" bgcolor="#8FBF21" onclick="saveChargingTag();"></etc:ModernButton>
    </c:if>
    <etc:ModernButton text='${m["Close"]}' image="Cancel_50px_white.png" color="#FFF" bgcolor="#b7b7b7" onclick="closeChargingTagDialog()"/>
</div>

<script>

    function saveChargingTag(){
        $(".etc_errortext").hide();
        var formData = $('#chargingTagForm').serializeArray().reduce(function(obj, item) {
            obj[item.name] = item.value;
            return obj;
        }, {});

        formData.customer_id = '${solutionDb}';

        $.ajax({
            url: "/SaveChargingTag.ajax",
            type : "POST",
            dataType: "json",
            data: formData,
            success: function(data){
                if(!data || data.error) {
                    failedChargingTagSave(data);
                    return;
                }else {
                    if(data.chargingTagId){
                        jsChargingTagOverview.newTagId = data.chargingTagId;
                    }
                    closeChargingTagDialog();
                }
            }
        });
    }

    function singleSaveChargingTag(field){
        $(".etc_errortext").hide();
        var formData = $('#chargingTagForm').serializeArray().reduce(function(obj, item) {
            obj[item.name] = item.value;
            return obj;
        }, {});

        var data = {};
        data.customer_id = '${solutionDb}';
        data[field] = formData[field];
        data.chargingTagId = '${chargingTagId}';
        data.singleField = field;
        $.ajax({
            url: "/SaveChargingTag.ajax",
            type : "POST",
            dataType: "json",
            data: data,
            success: function(data){
                if(!data || data.error) {
                    failedChargingTagSave(data);
                    return;
                }
            }
        });
    }

    function closeChargingTagDialog(){
        $("#dialogLinkItem").dialog("close");
        <c:if test="${not fromAssetSettings}">
        jsChargingTagOverview.getReport();
        </c:if>
    }
</script>