<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
         pageEncoding="ISO-8859-1"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="etc" uri="/WEB-INF/tags.tld"%>
<script src="/script/etc_DataGrid.js" ></script>
<script src="/script/etc_ReportFilter.js" ></script>
<link rel="stylesheet" type="text/css" href="/view/theme/ETC/bsdatetimepicker/bootstrap-datepicker3.standalone.min.css">
<script type="text/javascript" src="/view/theme/ETC/bsdatetimepicker/bootstrap-datepicker.min.js" ></script>
<etc:OverviewReport
        params="${chargingTagParameters}"
        dataGridName="ChargingTagOverview"
        ajaxUrl="ChargingTagReport"
        noDataMsg="${m['ChargingTag.NoData']}"
        tableFields="${mainLayout}"
        detailsFunction="loadChargeTagDetails"
        refreshFunction="reloadChargingTagOverview"
        exportReportUrl="ChargingTagExport.ajax"
        gridConditions=""
        hasLocChooser="${hasLocChooser}"
        dataParameters="${dataGridParameters}"
        headers="true"
/>
<div id="chargingTagDialogs">
    <div id="customerDialog"></div>
</div>
<script>
    function loadChargeTagDetails(id){
        $.ajax({
            url: "/${solutionUrl}/x/ChargingTagDetails",
            type: "POST",
            dataType:"html",
            data: {
                chargingTagId: id
            },
            success:function(data){
                loadReportDetails(id, data);
            }
        });
    }

    function removeUserBinding(tagId, userId, userName){
        var caption = "${m['ChargingTag.RemoveBinding']}";
        var message = "${m['ChargingTag.RemoveBindingComfirm']}"+" "+userName+"?";
        var ok = "${m['Confirm']}";
        var cancel = "${m['Cancel']}";
        etcconfirmnew(message,function() {
            var data = {};
            data.deleteUserBinding = true;
            data.chargingTagId = tagId;
            data.deleteUserId = userId
            deleteTagBinding(data);
        },null, caption,ok, cancel);
    }

    function removeAssetBinding(tagId, assetNo, carId){
        var caption = "${m['ChargingTag.RemoveBinding']}";
        var message = "${m['ChargingTag.RemoveBindingComfirm']}"+" "+carId+"?";
        var ok = "${m['Confirm']}";
        var cancel = "${m['Cancel']}";
        etcconfirmnew(message,function() {
            var data = {};
            data.deleteAssetBinding = true;
            data.chargingTagId = tagId;
            data.deleteAssetId = assetNo
            deleteTagBinding(data);
        },null, caption,ok, cancel);
    }

    function removeProviderBinding(tagId, providerId, providerName){
        var caption = "${m['ChargingTag.RemoveBinding']}";
        var message = "${m['ChargingTag.RemoveBindingComfirm']}"+" "+providerName+"?";
        var ok = "${m['Confirm']}";
        var cancel = "${m['Cancel']}";
        etcconfirmnew(message,function() {
            var data = {};
            data.deleteProvider = true;
            data.chargingTagId = tagId;
            data.deleteProviderId = providerId
            deleteTagBinding(data);
        },null, caption,ok, cancel);
    }

    function deleteTagBinding(data){
        data.customer_id = '${solutionDb}';
        $.ajax({
            url: "/${solutionUrl}/x/ChargingTagBindingDialog",
            type : "POST",
            dataType: "json",
            data: data,
            success: function(data){
                if(data && data.deletedok){
                    jsChargingTagOverview.getReport();
                }else{
                    failedBindingRemove();
                }
            }
        });
    }

    function  failedBindingRemove() {
        var caption = "${m['ChargingTag.RemoveBindingError']}";
        var message = "${m['ChargingTag.RemoveBindingErrorText']}";
        var ok = "${m['OK']}";
        etcconfirmnew(message, function(){jsChargingTagOverview.getReport();}, null, caption,ok, null,null,true);
    }

    var openDetails = [];
    function preserveChargeTagDetails() {
        var rememberDetails = [];
        $('#FuelCardOverviewWrapper').find('tr.reportDetailRow').each(function() { rememberDetails.push($(this).prev().attr('data-id') ); } );

        openDetails  = rememberDetails;
    }

    function afterChargeTagReportLoaded() {
        if(jsChargingTagOverview.newTagId){
            var d = jsChargingTagOverview.newTagId;
            var reportDetailBtn = $('#FuelCardOverviewWrapper').find('tr[data-id='+ d + ']').find('.reportDetailsButton');

            if(reportDetailBtn.length != 0) {
                showReportDetails(d, loadChargeTagDetails, reportDetailBtn );
            }
            jsChargingTagOverview.newTagId = null;
        }
        if(openDetails != null && openDetails.length > 0) {
            $.each(openDetails, function(i,d){
                var reportDetailBtn = $('#FuelCardOverviewWrapper').find('tr[data-id='+ d + ']').find('.reportDetailsButton');

                if(reportDetailBtn.length != 0) {
                    showReportDetails(d, loadChargeTagDetails, reportDetailBtn );
                }
            });
        }
    }

    function registerRFID() {
        var result = getChosenRows()
        var data = {}
        data.kjoretoy = result.kjoretoy
        data.rfidbrikker = result.rfidbrikker


        dialogLinkItemShow("${solutionUrl}/x/ChargingProviderRegisterDialog",{
            kjoretoy: data.kjoretoy,
            rfidbrikker: data.rfidbrikker,
        },);

    }

    //Laget av Elliot til bachelor oppgave
    function getChosenRows() {
        var rows = $("#ChargingTagOverviewDataHolder").find("tr");
        var kjoretoy = "";
        var rfidbrikker = "";
        let a = 0;
        let b = 0;
        $.each(rows, function(i,cb){
            var checkNr = $(this).attr("data-id")
            var checked = $("input#checkbox"+checkNr).prop("checked")
            if($(this).attr("data-assets") && checked){
                if(a>0) {
                    kjoretoy+=",";
                }
                kjoretoy += $(this).attr("data-assets");
                a++;
            }
            if($(this).attr("data-rfidNumber") && checked ) {
                if(b>0) {
                    rfidbrikker+=",";
                }
                rfidbrikker += $(this).attr("data-rfidNumber");
                b++;
            }
        });

        var data = {}
        data.rfidbrikker = rfidbrikker
        data.kjoretoy = kjoretoy

        return data
    }

    $(document).ready(function(){
        jsChargingTagOverview.beforeGetReport = preserveChargeTagDetails;
        jsChargingTagOverview.onLoaded = afterChargeTagReportLoaded;
    });
</script>