package Functional.Charging;


import etc.caradmin.mvc.controller.charging.EnodeWebhookAPI;
import etc.caradmin.mvc.controller.charging.GetChargingDataEnode;
import org.json.JSONArray;
import org.json.JSONObject;
import org.junit.jupiter.api.Test;
import java.util.ArrayList;
import java.util.List;

import static org.junit.jupiter.api.Assertions.*;

public class ChargingTest {


    @Test
    void testGetAccessToken(){
        GetChargingDataEnode charging = new GetChargingDataEnode();

        try{

            String token = charging.getAccesToken();
            assertNotNull(token);

        }catch(Exception e){
            e.printStackTrace();
        }
    }

    @Test
    void testGetChargingData(){
        GetChargingDataEnode charging = new GetChargingDataEnode();

        try{

            String token = charging.getAccesToken();
            String json = charging.getChargingData("autodb", "447146d9-1d4b-4abd-92d4-458b7a4e4298",
                                                   "2022-04-04", token);
            assertNotNull(json);

        }catch(Exception e){
            e.printStackTrace();
        }
    }

    @Test
    void testFindReleventEvent(){

        EnodeWebhookAPI enodeClass = new EnodeWebhookAPI();

        //Json array som brukes til  lete etter relevant event.
        String jsonStr = "[ \n" +
                "    { \n" +
                "        \"createdAt\": \"2022-03-30T10:41:53.645Z\",\n" +
                "        \"event\": \"user:charger:discovered\",\n" +
                "        \"user\": {\n" +
                "            \"id\": \"autodb\"\n" +
                "        },\n" +
                "        \"charger\": {\n" +
                "            \"id\": \"7dd4512d-fa6c-4a9a-8256-8d5eb37edce7\",\n" +
                "            \"lastSeen\": null,\n" +
                "            \"isReachable\": false,\n" +
                "            \"chargeState\": {\n" +
                "                \"isPluggedIn\": false,\n" +
                "                \"isCharging\": false,\n" +
                "                \"chargeRate\": null,\n" +
                "                \"lastUpdated\": null\n" +
                "            },\n" +
                "            \"information\": {\n" +
                "                \"id\": \"7dd4512d-fa6c-4a9a-8256-8d5eb37edce7\",\n" +
                "                \"brand\": \"Easee\",\n" +
                "                \"model\": \"ZCH041944\",\n" +
                "                \"year\": 2020\n" +
                "            }\n" +
                "        }\n" +
                "    },\n" +
                "    {\n" +
                "        \"createdAt\": \"2022-03-30T10:41:53.647Z\",\n" +
                "        \"event\": \"user:charger:discovered\",\n" +
                "        \"user\": {\n" +
                "            \"id\": \"autodb\"\n" +
                "        },\n" +
                "        \"charger\": {\n" +
                "            \"id\": \"447146d9-1d4b-4abd-92d4-458b7a4e4298\",\n" +
                "            \"lastSeen\": null,\n" +
                "            \"isReachable\": false,\n" +
                "            \"chargeState\": {\n" +
                "                \"isPluggedIn\": false,\n" +
                "                \"isCharging\": false,\n" +
                "                \"chargeRate\": null,\n" +
                "                \"lastUpdated\": null\n" +
                "            },\n" +
                "            \"information\": {\n" +
                "                \"id\": \"447146d9-1d4b-4abd-92d4-458b7a4e4298\",\n" +
                "                \"brand\": \"Easee\",\n" +
                "                \"model\": \"ZCH041944\",\n" +
                "                \"year\": 2022\n" +
                "            }\n" +
                "        }\n" +
                "    },\n" +
                "    {\n" +
                "        \"createdAt\": \"2022-03-30T10:41:53.652Z\",\n" +
                "        \"event\": \"user:charger:discovered\",\n" +
                "        \"user\": {\n" +
                "            \"id\": \"autodb\"\n" +
                "        },\n" +
                "        \"charger\": {\n" +
                "            \"id\": \"c5ea7cd5-269a-4bf7-b983-579fbcb08344\",\n" +
                "            \"lastSeen\": null,\n" +
                "            \"isReachable\": false,\n" +
                "            \"chargeState\": {\n" +
                "                \"isPluggedIn\": false,\n" +
                "                \"isCharging\": false,\n" +
                "                \"chargeRate\": null,\n" +
                "                \"lastUpdated\": null\n" +
                "            },\n" +
                "            \"information\": {\n" +
                "                \"id\": \"c5ea7cd5-269a-4bf7-b983-579fbcb08344\",\n" +
                "                \"brand\": \"Easee\",\n" +
                "                \"model\": \"ZCH041944\",\n" +
                "                \"year\": 2021\n" +
                "            }\n" +
                "        }\n" +
                "    },\n" +
                "    {\n" +
                "        \"createdAt\": \"2022-03-30T10:56:04.401Z\",\n" +
                "        \"event\": \"user:charger:updated\",\n" +
                "        \"user\": {\n" +
                "            \"id\": \"autodb\"\n" +
                "        },\n" +
                "        \"charger\": {\n" +
                "            \"id\": \"447146d9-1d4b-4abd-92d4-458b7a4e4298\",\n" +
                "            \"lastSeen\": \"2022-04-01T10:56:04.351Z\",\n" +
                "            \"isReachable\": true,\n" +
                "            \"chargeState\": {\n" +
                "                \"isPluggedIn\": false,\n" +
                "                \"isCharging\": false,\n" +
                "                \"chargeRate\": 0,\n" +
                "                \"lastUpdated\": \"2022-04-18T11:43:36.067Z\"\n" +
                "            },\n" +
                "            \"information\": {\n" +
                "                \"id\": \"447146d9-1d4b-4abd-92d4-458b7a4e4298\",\n" +
                "                \"brand\": \"Easee\",\n" +
                "                \"model\": \"ZCH041944\",\n" +
                "                \"year\": 2022\n" +
                "            }\n" +
                "        },\n" +
                "        \"updatedFields\": [\n" +
                "            \"lastSeen\",\n" +
                "            \"updatedAt\",\n" +
                "            \"chargeStateIsPluggedIn\"\n" +
                "        ]\n" +
                "    }\n" +
                "]";

        String jsonObjTemp = "{\n" +
                "        \"createdAt\": \"2022-03-30T10:56:04.401Z\",\n" +
                "        \"event\": \"user:charger:updated\",\n" +
                "        \"user\": {\n" +
                "            \"id\": \"autodb\"\n" +
                "        },\n" +
                "        \"charger\": {\n" +
                "            \"id\": \"447146d9-1d4b-4abd-92d4-458b7a4e4298\",\n" +
                "            \"lastSeen\": \"2022-04-01T10:56:04.351Z\",\n" +
                "            \"isReachable\": true,\n" +
                "            \"chargeState\": {\n" +
                "                \"isPluggedIn\": false,\n" +
                "                \"isCharging\": false,\n" +
                "                \"chargeRate\": 0,\n" +
                "                \"lastUpdated\": \"2022-04-18T11:43:36.067Z\"\n" +
                "            },\n" +
                "            \"information\": {\n" +
                "                \"id\": \"447146d9-1d4b-4abd-92d4-458b7a4e4298\",\n" +
                "                \"brand\": \"Easee\",\n" +
                "                \"model\": \"ZCH041944\",\n" +
                "                \"year\": 2022\n" +
                "            }\n" +
                "        },\n" +
                "        \"updatedFields\": [\n" +
                "            \"lastSeen\",\n" +
                "            \"updatedAt\",\n" +
                "            \"chargeStateIsPluggedIn\"\n" +
                "        ]\n" +
                "    }";


        JSONObject jsonObj = new JSONObject(jsonObjTemp);

        List<JSONObject> objList = new ArrayList<>();
        objList.add(jsonObj);

        JSONArray jsonArr = new JSONArray(jsonStr);

        List<JSONObject> jsonObjListFound = enodeClass.findReleventEvent(jsonArr);


        assertEquals(objList.toString(), jsonObjListFound.toString());

    }

    @Test
    void testMakeQuery(){

        EnodeWebhookAPI enodeClass = new EnodeWebhookAPI();

        String json = "[{\"kw\":{\"min\":5,\"max\":15,\"mean\":10},\"kwhSum\":12,\"price\":{\"min\":0.5,\"max\":1,\"mean\":0.75},\"costSum\":9.600000000000001,\"smartSession\":true,\"nonSmartPrice\":{\"min\":0,\"max\":0,\"mean\":0},\"nonSmartCostSum\":0,\"estimatedSavings\":0,\"date\":\"2022-04-18T00:00:00.000Z\"}," +
                       "{\"kw\":{\"min\":5,\"max\":15,\"mean\":10},\"kwhSum\":12,\"price\":{\"min\":0.5,\"max\":1,\"mean\":0.75},\"costSum\":9.600000000000001,\"smartSession\":true,\"nonSmartPrice\":{\"min\":0,\"max\":0,\"mean\":0},\"nonSmartCostSum\":0,\"estimatedSavings\":0,\"date\":\"2022-04-19T00:00:00.000Z\"}," +
                       "{\"kw\":{\"min\":5,\"max\":15,\"mean\":10},\"kwhSum\":12,\"price\":{\"min\":0.5,\"max\":1,\"mean\":0.75},\"costSum\":9.600000000000001,\"smartSession\":true,\"nonSmartPrice\":{\"min\":0,\"max\":0,\"mean\":0},\"nonSmartCostSum\":0,\"estimatedSavings\":0,\"date\":\"2022-04-20T00:00:00.000Z\"}]";

        String brand = "Easee";
        String chargerId = "447146d9-1d4b-4abd-92d4-458b7a4e4298";

        try {
            String query = enodeClass.makeQuery(json, brand, chargerId);
            String expectedQuery = "INSERT INTO charging (chargerId, date, brand, price, kwh) VALUES " +
                    "('447146d9-1d4b-4abd-92d4-458b7a4e4298', '2022-04-18 00:00:00','Easee', 0.0, 12.0)," +
                    "('447146d9-1d4b-4abd-92d4-458b7a4e4298', '2022-04-19 00:00:00','Easee', 0.0, 12.0)," +
                    "('447146d9-1d4b-4abd-92d4-458b7a4e4298', '2022-04-20 00:00:00','Easee', 0.0, 12.0)";

            assertEquals(query, expectedQuery);

        }catch(Exception e){
            e.printStackTrace();
        }

    }

}
